import { isSameDay, isSameMonth } from 'date-fns';
export function createTabIndex(day, modifiers, props) {
    if (!modifiers.interactive)
        return;
    var tabIndex;
    if (props.focusedDay && isSameDay(day, props.focusedDay)) {
        tabIndex = 0;
    }
    else if (isSameDay(day, new Date())) {
        tabIndex = 0;
    }
    else if (!isSameDay(day, new Date()) &&
        !isSameMonth(day, new Date()) &&
        day.getDate() === 1) {
        tabIndex = 0;
    }
    else {
        tabIndex = -1;
    }
    return tabIndex;
}
//# sourceMappingURL=createTabIndex.js.map