import { matchDay } from './matchModifier';
var reduceCallback = function (day, matchers) { return function (previousValue, key) {
    var matcher = matchers[key];
    if (matchDay(day, matcher)) {
        previousValue.push(key);
    }
    return previousValue;
}; };
/**
 * Given a date and a list of modifiers to look for, return the names of the modifiers
 * matching that day.
 */
export function findModifiers(day, matchers) {
    return Object.keys(matchers).reduce(reduceCallback(day, matchers), []);
}
//# sourceMappingURL=findModifiers.js.map