import { addMonths, startOfMonth } from 'date-fns';
/**
 * Returns the next and the previous months that the user can navigate to.
 */
export function getPrevNextMonths(props) {
    var fromMonth = props.fromMonth, toMonth = props.toMonth, month = props.month, numberOfMonths = props.numberOfMonths, pagedNavigation = props.pagedNavigation;
    var add = pagedNavigation ? numberOfMonths : 1;
    var currentMonth = startOfMonth(month !== null && month !== void 0 ? month : props.today);
    var prevMonth;
    if (!fromMonth || currentMonth > startOfMonth(fromMonth)) {
        prevMonth = addMonths(currentMonth, add * -1);
    }
    var nextMonth;
    if (!toMonth ||
        addMonths(currentMonth, numberOfMonths) <= startOfMonth(toMonth)) {
        nextMonth = addMonths(currentMonth, add);
    }
    return [prevMonth, nextMonth];
}
//# sourceMappingURL=getPrevNextMonths.js.map