import { getUnixTime } from 'date-fns';
import * as React from 'react';
export function Row(props) {
    var weekNumber = props.weekNumber, week = props.week, currentMonth = props.currentMonth, dayPickerProps = props.dayPickerProps;
    var labelsFormatters = dayPickerProps.labelsFormatters, showWeekNumber = dayPickerProps.showWeekNumber, formatWeekNumber = dayPickerProps.formatWeekNumber, locale = dayPickerProps.locale, classNames = dayPickerProps.classNames, styles = dayPickerProps.styles, components = dayPickerProps.components;
    var Day = components.Day;
    return (React.createElement("tr", { className: classNames === null || classNames === void 0 ? void 0 : classNames.Row, style: styles === null || styles === void 0 ? void 0 : styles.Row },
        showWeekNumber && (React.createElement("th", { className: classNames === null || classNames === void 0 ? void 0 : classNames.RowHead, style: styles === null || styles === void 0 ? void 0 : styles.RowHead, "aria-label": labelsFormatters.rowHead(Number(weekNumber), dayPickerProps) }, formatWeekNumber(Number(weekNumber), { locale: locale }))),
        week.map(function (day) { return (React.createElement("td", { className: classNames === null || classNames === void 0 ? void 0 : classNames.Cell, style: styles === null || styles === void 0 ? void 0 : styles.Cell, key: getUnixTime(day) },
            React.createElement(Day, { day: day, dayPickerProps: dayPickerProps, currentMonth: currentMonth }))); })));
}
//# sourceMappingURL=Row.js.map