import * as React from 'react';
import { Head } from '../Head';
import { Row } from '../Row';
import { getWeeks } from './utils/getWeeks';
export function Table(props) {
    var month = props.month, dayPickerProps = props.dayPickerProps;
    var classNames = dayPickerProps.classNames, styles = dayPickerProps.styles, showCaption = dayPickerProps.showCaption, showHead = dayPickerProps.showHead, components = dayPickerProps.components;
    var Caption = components.Caption;
    var weeks = getWeeks(month, dayPickerProps);
    return (React.createElement("table", { className: classNames === null || classNames === void 0 ? void 0 : classNames.Table, style: styles === null || styles === void 0 ? void 0 : styles.Table },
        showCaption && React.createElement(Caption, { month: month, dayPickerProps: dayPickerProps }),
        showHead && React.createElement(Head, { dayPickerProps: dayPickerProps }),
        React.createElement("tbody", { className: classNames === null || classNames === void 0 ? void 0 : classNames.TBody, style: styles === null || styles === void 0 ? void 0 : styles.TBody }, Object.keys(weeks).map(function (weekNumber) { return (React.createElement(Row, { currentMonth: month, key: weekNumber, week: weeks[weekNumber], weekNumber: Number(weekNumber), dayPickerProps: dayPickerProps })); }))));
}
//# sourceMappingURL=Table.js.map