import { isSameDay } from 'date-fns';
var emptyRange = { from: undefined, to: undefined };
/**
 * Add a day to an existing range.
 *
 * The returned range takes in account the `undefined` values and if the added
 * day is already present in the range.
 */
export function addToRange(range, day) {
    var from = range.from, to = range.to;
    if (!from) {
        return { from: day };
    }
    if (!to && isSameDay(from, day)) {
        return emptyRange;
    }
    if (!to) {
        return { from: from, to: day };
    }
    if (isSameDay(to, day)) {
        return { from: to };
    }
    return { from: from, to: day };
}
//# sourceMappingURL=addToRange.js.map