import { DaysRange } from '../../types/DaysRange';
/**
 * Returns a range and a state setter for handing ranges when selecting dates.
 *
 * **Example**
 *
 * ```jsx showOutput open=false
 * function Example() {
 *   const [range, setRange] = useRange();
 *   return <DayPicker onDayClick={setRange} selected={range} />;
 * }
 * ```
 */
export declare function useRange(initialRange?: DaysRange): [DaysRange, (day: Date) => void];
